# coding: utf-8

"""
    Live Data People API

    This API provides information about people as observed by Live Data

    The version of the OpenAPI document: 1.0
    Contact: support@livedatatechnologies.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PersonEducationInner(BaseModel):
    """
    PersonEducationInner
    """ # noqa: E501
    school: Optional[StrictStr] = Field(default=None, description="Name of the school")
    var_field: Optional[StrictStr] = Field(default=None, description="Name of the field of study", alias="field")
    degree: Optional[StrictStr] = Field(default=None, description="Name of the degree the person achieved")
    started_at: Optional[StrictStr] = Field(default=None, description="Started at date. Will always be the 1st day of a month at 00:00")
    ended_at: Optional[StrictStr] = Field(default=None, description="Ended at date. Will always be the 1st day of a month at 00:00")
    __properties: ClassVar[List[str]] = ["school", "field", "degree", "started_at", "ended_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PersonEducationInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PersonEducationInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "school": obj.get("school"),
            "field": obj.get("field"),
            "degree": obj.get("degree"),
            "started_at": obj.get("started_at"),
            "ended_at": obj.get("ended_at")
        })
        return _obj


