# coding: utf-8

"""
    Live Data People API

    This API provides information about people as observed by Live Data

    The version of the OpenAPI document: 1.0
    Contact: support@livedatatechnologies.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ldt_people_client_staging.models.agg_request import AggRequest
from ldt_people_client_staging.models.filter_group import FilterGroup
from typing import Optional, Set
from typing_extensions import Self

class SearchPersonsDataRequest(BaseModel):
    """
    SearchPersonsDataRequest
    """ # noqa: E501
    filters: Optional[List[FilterGroup]] = None
    return_fields: Optional[List[StrictStr]] = Field(default=None, description="List of field names to return. For nested JSON fields, use dot notation (i.e. jobs.company.name)")
    past_jobs: Optional[StrictInt] = Field(default=None, description="How many previous jobs to include in the data")
    size: Optional[StrictInt] = Field(default=None, description="The number of records to return in each page of the search. Defaults to 10. ")
    pagination_token: Optional[StrictStr] = Field(default=None, description="If provided, returns the next page of data based on the `pagination_token`.     The `pagination_token` is only valid for a given set of filters/size -- the same `filters` and `size` must be supplied for every call using the `pagination_token` from a response with those filters. If the filters/size don't match the pagination_token, this call will return a `400`.")
    sort_by: Optional[StrictStr] = Field(default=None, description="Which field to sort on. Use the pattern +name to sort ascending and -name to sort descending.")
    aggs: Optional[List[AggRequest]] = None
    __properties: ClassVar[List[str]] = ["filters", "return_fields", "past_jobs", "size", "pagination_token", "sort_by", "aggs"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SearchPersonsDataRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in filters (list)
        _items = []
        if self.filters:
            for _item_filters in self.filters:
                if _item_filters:
                    _items.append(_item_filters.to_dict())
            _dict['filters'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in aggs (list)
        _items = []
        if self.aggs:
            for _item_aggs in self.aggs:
                if _item_aggs:
                    _items.append(_item_aggs.to_dict())
            _dict['aggs'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SearchPersonsDataRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "filters": [FilterGroup.from_dict(_item) for _item in obj["filters"]] if obj.get("filters") is not None else None,
            "return_fields": obj.get("return_fields"),
            "past_jobs": obj.get("past_jobs"),
            "size": obj.get("size"),
            "pagination_token": obj.get("pagination_token"),
            "sort_by": obj.get("sort_by"),
            "aggs": [AggRequest.from_dict(_item) for _item in obj["aggs"]] if obj.get("aggs") is not None else None
        })
        return _obj


